class krySubReaderSSA : public krySubReader, public krySubSSA
{
public:
  krySubReaderSSA(char *filename);

  enum retval ReadScript(kryScript *script, kryList<kryTextParseError *> *list);

  enum sub_ssa_section
  {
    SECTION_NONE,
    SECTION_INFO,
    SECTION_V4_STYLES,
    SECTION_V4P_STYLES,
    SECTION_EVENTS
  };

private:

  kryList<struct krySubSSAColumnInfo *> *BuildColumnList(char *buffer, int mask);
  void FreeColumnList(kryList<struct krySubSSAColumnInfo *> *list);
  
  void ParseData(char *buffer, kryList<struct krySubSSAColumnInfo *> *column_list, void *object);
  kryStyle *ParseStyleLine(char *buffer, kryList<struct krySubSSAColumnInfo *> *style_column_list, gboolean script_ass);
  kryEventDetailed *ParseEventLine(char *buffer, char *type, kryList<struct krySubSSAColumnInfo *> *event_column_list);
};


