enum event_action
{
  EVENT_COPY,
  EVENT_CUT,
  EVENT_DELETE
};

enum event_action_loc
{
  EVENT_ADD_BLANK_AFTER,
  EVENT_ADD_BLANK_BEFORE,
  EVENT_ADD_SEPARATOR_AFTER,
  EVENT_ADD_SEPARATOR_BEFORE,
  EVENT_PASTE_AFTER,
  EVENT_PASTE_BEFORE
};

enum event_split_type
{
  EVENT_SPLIT_AUTO,
  EVENT_SPLIT_CURSOR
};


void gui_main_menu_event_type(GtkWidget *menu_item, gpointer data);
void gui_main_menu_event_add(gpointer callback_data, enum event_action_loc loc, GtkWidget *menu_item);
void gui_main_menu_event_delete(gpointer callback_data, guint callback_action, GtkWidget *menu_item);
void gui_main_menu_event_paste(gpointer callback_data, enum event_action_loc loc, GtkWidget *menu_item);
void gui_main_menu_event_clipboard(gpointer callback_data, enum event_action loc, GtkWidget *menu_item);
//void gui_main_event_update_index();

void gui_main_menu_event_join(gpointer callback_data, guint callback_action, GtkWidget *menu_item);
void gui_main_menu_event_split(gpointer callback_data, enum event_split_type, GtkWidget *menu_item);

void gui_main_menu_number_events(GtkWidget *menu, void *param);

void gui_main_event_current_save_text();


void gui_event_name_list_clear();
void gui_event_name_list_add(char *name);
void gui_event_name_list_remove(char *name);




