/* 
 *	Copyright (C) 2004-2005 Vadim Berezniker
 *	http://www.kryptolus.com
 *
 *  This Program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  This Program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *  http://www.gnu.org/copyleft/gpl.html
 *
 */
#include "stdafx.h"

#include "common.h"

#include "sabbu.h"

kryEventKaraokeTime::kryEventKaraokeTime()
{
  ((kryEvent *) (this))->SetType(kryEvent::EVENT_KARAOKE_TIME);
}

kryEventKaraokeText *kryEventKaraokeTime::GetEventText()
{
  return this->m_event_text;
}

void kryEventKaraokeTime::SetEventText(kryEventKaraokeText *event)
{
  this->m_event_text = event;
}

int kryEventKaraokeTime::GetParamLength()
{
  return this->m_param_length;
}

void kryEventKaraokeTime::SetParamLength(int length)
{
  this->m_param_length = length;
}

int kryEventKaraokeTime::GetParamOffset()
{
  return this->m_param_offset;
}

void kryEventKaraokeTime::SetParamOffset(int offset)
{
  this->m_param_offset = offset;
}

