#include "kryObject.h"

class kryUiGTK: public kryObject
{
public:
  kryUiGTK();

  void ScriptChangedBeforeCallback(kryObject *obj, kryScript *script);
  static void ScriptChangedBeforeCallbackW(kryObject *obj, kryScript *script, kryUiGTK *ui);

  void ScriptChangedAfterCallback(kryObject *obj, kryScript *script);
  static void ScriptChangedAfterCallbackW(kryObject *obj, kryScript *script, kryUiGTK *ui);

  static void EventCollisionCallbackW(kryObject *kryobj, int index, kryUiGTK *obj);
  void EventCollisionCallback(kryScript *obj, int index);  

  static void EventNameAddedCallbackW(kryObject *kryobj, char *name, kryUiGTK *obj);
  void EventNameAddedCallback(char *name);

  static void EventNameDeletedCallbackW(kryObject *kryobj, char *name, kryUiGTK *obj);
  void EventNameDeletedCallback(char *name);

  static void EventModifiedCallbackW(kryObject *kryobj, gboolean modified, kryUiGTK *obj);
  void EventModifiedCallback(gboolean modified);

  static void EventTypeChangedCallbackW(kryObject *kryobj, enum kryScriptType type, kryUiGTK *obj);
  void EventTypeChangedCallback(kryScript *script, enum kryScriptType type);

  static void EventAddedCallbackW(kryObject *kryobj, kryEventDetailed *event, kryUiGTK *obj);
  void EventAddedCallback(kryObject *kryobj, kryEventDetailed *event);

  static void EventRemovedCallbackW(kryObject *kryobj, kryEventDetailed *event, kryUiGTK *obj);
  void EventRemovedCallback(kryObject *kryobj, kryEventDetailed *event);

  enum
  {
    SIGNAL_COUNT
  };
};


